import direct.directbase.DirectStart
from pandac.PandaModules import *
from direct.gui.OnscreenText import OnscreenText
import sys
from input_control import inputManager


class playerFps():
	def __init__(self):
		self.keymap = inputManager().keymap

		self.node = NodePath('player')
		self.node.reparentTo(render)
		base.camera.reparentTo(self.node)
		self.node.setPos(0,0,2)
		startpos = self.node.getPos()
		
		#Camera lens settings
		pl = base.cam.node().getLens()
		pl.setFov(70)
		base.cam.node().setLens(pl)
		
		#load terrain
		plane =loader.loadModel('assets/towers')
		plane.reparentTo(render)
		plane.setCollideMask(BitMask32.allOff())
		plane.setScale(100)
		#Collision
		self.cTrav = CollisionTraverser()
		base.cTrav = self.cTrav
		self.cTrav.traverse(render)
		self.FLOOR_MASK = BitMask32.bit(1)
		
		self.floorHandler = CollisionHandlerFloor()
		self.floorHandler.setMaxVelocity(14)
		
		self.raygeomtery = CollisionRay(0, 0, 0, 0, 0, -1)
		self.playerRay = self.node.attachNewNode(CollisionNode('playerRay'))
		self.playerRay.node().addSolid(self.raygeomtery)
		self.playerRay.node().setFromCollideMask(self.FLOOR_MASK)
		self.playerRay.node().setIntoCollideMask(BitMask32.allOff())
		
		self.floorcollider = plane.find("**/floor_collide")
		self.floorcollider.node().setIntoCollideMask(self.FLOOR_MASK)
		self.floorHandler.addCollider(self.playerRay, self.node)
		self.floorHandler.setOffset(5)
		
		self.cTrav.addCollider(self.playerRay, self.floorHandler)
		
	def mouseUpdate(self,task):
		self.centerx =  base.win.getProperties().getXSize()/2
		self.centery =  base.win.getProperties().getYSize()/2
		md = base.win.getPointer(0)
		x = md.getX()
		y = md.getY()
		if base.win.movePointer(0, base.win.getXSize()/2, base.win.getYSize()/2):
			self.node.setH(self.node.getH() -  (x - base.win.getXSize()/2)*0.1)
			self.node.setP(self.node.getP() - (y - base.win.getYSize()/2)*0.1)
			##prints x y cordiantes
			#print "x = %d" % x
			#print "y = %d" % y
			#print "h = %d" % self.node.getH()
			#print "p = %d" %self.node.getH()
		return task.cont
	def player_fps(self, task):
		dt = globalClock.getDt()
		if self.keymap['w'] == True:
			self.node.setY(self.node, 8 * dt)
		if self.keymap['a'] == True:
			self.node.setX(self.node, -8 * dt)
		if self.keymap['s'] == True:
			self.node.setY(self.node, -8 * dt)
		if self.keymap['d'] == True:
			self.node.setX(self.node, 8 * dt)
		return task.cont